? sldb-quit-restart.diff
Index: swank.lisp
===================================================================
RCS file: /project/slime/cvsroot/slime/swank.lisp,v
retrieving revision 1.379
diff -u -r1.379 swank.lisp
--- swank.lisp	25 May 2006 03:15:20 -0000	1.379
+++ swank.lisp	31 May 2006 17:13:46 -0000
@@ -2482,6 +2482,9 @@
 (defvar *sldb-stepping-p* nil
   "True when during execution of a stepp command.")
 
+(defvar *sldb-quit-restart* 'abort-request
+  "What restart should swank attempt to invoke when the user sldb-quits.")
+
 (defun debug-in-emacs (condition)
   (let ((*swank-debugger-condition* condition)
         (*sldb-restarts* (compute-restarts condition))
@@ -2617,9 +2620,11 @@
 (defslimefun throw-to-toplevel ()
   "Invoke the ABORT-REQUEST restart abort an RPC from Emacs.
 If we are not evaluating an RPC then ABORT instead."
-  (let ((restart (find-restart 'abort-request)))
+  (let ((restart (find-restart *sldb-quit-restart*)))
     (cond (restart (invoke-restart restart))
-          (t "Restart not found: ABORT-REQUEST"))))
+          (t (format nil
+                     "Restart not found: ~a"
+                     *sldb-quit-restart*)))))
 
 (defslimefun invoke-nth-restart-for-emacs (sldb-level n)
   "Invoke the Nth available restart.
